﻿Imports System.Runtime.CompilerServices

Namespace System.Drawing

   Public Module DrawingX

      Public ReadOnly RectangleMinValue As New Rectangle(Integer.MinValue, Integer.MinValue, Integer.MinValue, Integer.MinValue)
      Public ReadOnly PointMinValue As New Point(Integer.MinValue, Integer.MinValue)
      Public ReadOnly SizeMinValue As New Size(Integer.MinValue, Integer.MinValue)
      Public ReadOnly SizeBig As New Size(Short.MaxValue, Short.MaxValue)

      'Public ReadOnly SizeControlMin As New Size(50, 13)
      ''Public ReadOnly SizeControlMin As New Size(20, 13)

      'Public ReadOnly SizeControlDefault As New Size(50, 20)
      'Public ReadOnly SizeControlMin As New Size(20, 13)

      Public ReadOnly Size1 As New Size(1, 1)

#Region "Converters"

      <Extension()> _
      Public Function ToStringX(ByVal subj As SizeF) As String
         Return String.Concat("{", subj.Width, ", ", subj.Height, "}")
      End Function
      <Extension()> _
      Public Function ToStringX(ByVal subj As PointF) As String
         Return String.Concat("{", subj.X, ", ", subj.Y, "}")
      End Function
      <Extension()> _
      Public Function ToStringX(ByVal subj As RectangleF) As String
         Return String.Concat("{", subj.X, ", ", subj.Y, ", ", subj.Width, ", ", subj.Height, "}")
      End Function
      <Extension()> _
      Public Function ToStringX(ByVal subj As Size) As String
         Return String.Concat("{", subj.Width, ", ", subj.Height, "}")
      End Function
      <Extension()> _
      Public Function ToStringX(ByVal subj As Point) As String
         Return String.Concat("{", subj.X, ", ", subj.Y, "}")
      End Function
      <Extension()> _
      Public Function ToStringX(ByVal subj As Rectangle) As String
         Return String.Concat("{", subj.X, ", ", subj.Y, ", ", subj.Width, ", ", subj.Height, "}")
      End Function
      <Extension()> _
      Public Function Truncate(ByVal aSize As SizeF) As Size
         Return Size.Truncate(aSize)
      End Function
      <Extension()> _
      Public Function Truncate(ByVal aPoint As PointF) As Point
         Return Point.Truncate(aPoint)
      End Function

      <Extension()> _
      Public Function Ceiling(ByVal aSize As SizeF) As Size
         Return Size.Ceiling(aSize)
      End Function
      <Extension()> _
      Public Function Ceiling(ByVal aPoint As PointF) As Point
         Return Point.Ceiling(aPoint)
      End Function

      ''' <summary>returnt das dieses RectangleF umschließende Rectangle (Topleft abrunden, 
      ''' BottomRight aufrunden) - oder das eingeschriebene</summary>
      <Extension()> _
      Public Function RoundX(ByVal rct As RectangleF, ByVal expand As Boolean) As Rectangle
         With Rct
            If expand Then
               Dim TopLeft = Point.Truncate(New PointF(.X, .Y))
               Dim BottomRight = Size.Ceiling(New SizeF(.Right, .Bottom))
               Return New Rectangle(TopLeft, BottomRight - New Size(TopLeft))
            Else
               Dim TopLeft = Point.Ceiling(New PointF(.X, .Y))
               Dim BottomRight = Size.Truncate(New SizeF(.Right, .Bottom))
               Return New Rectangle(TopLeft, BottomRight - New Size(TopLeft))
            End If
         End With
      End Function

      <Extension()> _
      Public Function Round(ByVal aSize As SizeF) As Size
         Return Size.Round(aSize)
      End Function
      <Extension()> _
      Public Function Round(ByVal aPoint As PointF) As Point
         Return Point.Round(aPoint)
      End Function
      <Extension()> _
      Public Function Round(ByVal Rect As RectangleF) As Rectangle
         Return Rectangle.Round(Rect)
      End Function
      <Extension()> _
      Public Function ToFloat(ByVal aSize As Size) As SizeF
         Return aSize
      End Function
      <Extension()> _
      Public Function ToFloat(ByVal aPoint As Point) As PointF
         Return aPoint
      End Function
      <Extension()> _
      Public Function ToFloat(ByVal Rct As Rectangle) As RectangleF
         Return Rct
      End Function

      <Extension()> _
      Public Function ToSize(ByVal aPoint As Point) As Size
         Return New Size(aPoint)
      End Function
      <Extension()> _
      Public Function ToSizeF(ByVal aPoint As Point) As SizeF
         Return New SizeF(aPoint)
      End Function
      <Extension()> _
      Public Function ToSizeF(ByVal aPoint As PointF) As SizeF
         Return New SizeF(aPoint)
      End Function

      <Extension()> _
      Public Function ToPoint(ByVal aSize As Size) As Point
         Return New Point(aSize)
      End Function
      <Extension()> _
      Public Function ToPointF(ByVal aSize As Size) As PointF
         With aSize
            Return New PointF(.Width, .Height)
         End With
      End Function
      <Extension()> _
      Public Function ToPointF(ByVal aSize As SizeF) As PointF
         With aSize
            Return New PointF(.Width, .Height)
         End With
      End Function

      <Extension()> _
      Public Function ToRectangle(ByVal aSize As Size) As Rectangle
         Return New Rectangle(Point.Empty, aSize)
      End Function
      <Extension()> _
      Public Function ToRectangle(ByVal aSize As Size, ByVal Offset As Point) As Rectangle
         Return New Rectangle(Offset, aSize)
      End Function

      <Extension()> _
      Public Function ToRectangleF(ByVal aSize As Size) As RectangleF
         Return New RectangleF(PointF.Empty, aSize)
      End Function
      <Extension()> _
      Public Function ToRectangleF(ByVal aSize As Size, ByVal Offset As Point) As RectangleF
         Return New RectangleF(Offset, aSize)
      End Function

      <Extension()> _
      Public Function ToRectangleF(ByVal aSize As SizeF) As RectangleF
         Return New RectangleF(PointF.Empty, aSize)
      End Function
      <Extension()> _
      Public Function ToRectangleF(ByVal aSize As SizeF, ByVal Offset As PointF) As RectangleF
         Return New RectangleF(Offset, aSize)
      End Function

      <Extension()> _
      Public Function ToRectangle(ByVal Size As Point) As Rectangle
         With Size
            Return New Rectangle(0, 0, .X, .Y)
         End With
      End Function
      <Extension()> _
      Public Function ToRectangle(ByVal aPoint As Point, ByVal Size As Size) As Rectangle
         Return New Rectangle(aPoint, Size)
      End Function
      <Extension()> _
      Public Function ToRectangle(ByVal aPoint As Point, ByVal Size As Point) As Rectangle
         Return New Rectangle(aPoint, New Size(Size))
      End Function

      <Extension()> _
      Public Function ToRectangleF(ByVal aPoint As Point) As RectangleF
         With aPoint
            Return New RectangleF(0, 0, .X, .Y)
         End With
      End Function

      <Extension()> _
      Public Function ToRectangleF(ByVal aPoint As PointF) As RectangleF
         With aPoint
            Return New RectangleF(0, 0, .X, .Y)
         End With
      End Function

#End Region 'Converters

      <Extension()> _
      Public Function SquareDistance(ByVal subj As PointF, ByVal other As PointF) As Double
         Return (subj.X - other.X) ^ 2 + (subj.Y - other.Y) ^ 2
      End Function
      <Extension()> _
      Public Function Distance(ByVal subj As PointF, ByVal other As PointF) As Double
         Return subj.SquareDistance(other) ^ 0.5
      End Function
      <Extension()> _
      Public Function SquareDistance(ByVal subj As Point, ByVal other As Point) As Double
         Return (subj.X - other.X) ^ 2 + (subj.Y - other.Y) ^ 2
      End Function
      <Extension()> _
      Public Function Distance(ByVal subj As Point, ByVal other As Point) As Double
         Return subj.SquareDistance(other) ^ 0.5
      End Function

      <Extension()> _
      Public Function Item(ByVal subj As Size, ByVal vrtcl As Integer) As Integer
         If vrtcl = 0 Then Return subj.Width
         Return subj.Height
      End Function
      <Extension()> _
      Public Function Item(ByVal subj As Point, ByVal vrtcl As Integer) As Integer
         If vrtcl = 0 Then Return subj.X
         Return subj.Y
      End Function

      <Extension()> _
      Public Function Union(ByVal subj As Size, ByVal sz As Size) As Size
         If sz.Width > subj.Width Then subj.Width = sz.Width
         If sz.Height > subj.Height Then subj.Height = sz.Height
         Return subj
      End Function

      <Extension()> _
      Public Function Scale(ByVal Rct As RectangleF, ByVal Value As Single, _
              Optional ByVal Value2 As Single = Single.NaN) As RectangleF
         If Single.IsNaN(Value2) Then Value2 = Value
         With Rct
            Return New RectangleF(.X * Value, .Y * Value2, .Width * Value, .Height * Value2)
         End With
      End Function
      <Extension()> _
      Public Function Scale(ByVal Rct As Rectangle, ByVal Value As Single, _
              Optional ByVal Value2 As Single = Single.NaN) As RectangleF
         If Single.IsNaN(Value2) Then Value2 = Value
         With Rct
            Return New RectangleF(.X * Value, .Y * Value2, .Width * Value, .Height * Value2)
         End With
      End Function
      <Extension()> _
      Public Function Scale(ByVal Rct As Rectangle, ByVal Value As Integer, _
               Optional ByVal Value2 As Integer = Integer.MaxValue) As Rectangle
         If Value2 = Integer.MaxValue Then Value2 = Value
         With Rct
            Return New Rectangle(.X * Value, .Y * Value2, .Width * Value, .Height * Value2)
         End With
      End Function

      <Extension()> _
      Public Function Scale(ByVal Pt As PointF, ByVal Pt2 As PointF) As PointF
         With Pt
            Return New PointF(.X * Pt2.X, .Y * Pt2.Y)
         End With
      End Function
      <Extension()> _
      Public Function Scale(ByVal Pt As PointF, ByVal Value As Single, _
              Optional ByVal Value2 As Single = Single.NaN) As PointF
         If Single.IsNaN(Value2) Then Value2 = Value
         With Pt
            Return New PointF(.X * Value, .Y * Value2)
         End With
      End Function
      <Extension()> _
      Public Function Scale(ByVal Pt As Point, ByVal Value As Single, _
              Optional ByVal Value2 As Single = Single.NaN) As PointF
         If Single.IsNaN(Value2) Then Value2 = Value
         With Pt
            Return New PointF(.X * Value, .Y * Value2)
         End With
      End Function
      <Extension()> _
      Public Function Scale(ByVal Pt As Point, ByVal Value As Integer, _
              Optional ByVal Value2 As Integer = Integer.MaxValue) As Point
         If Value2 = Integer.MaxValue Then Value2 = Value
         With Pt
            Return New Point(.X * Value, .Y * Value2)
         End With
      End Function

      <Extension()> _
      Public Function Scale(ByVal Sz As SizeF, ByVal Value As Single, _
              Optional ByVal Value2 As Single = Single.NaN) As SizeF
         If Single.IsNaN(Value2) Then Value2 = Value
         With Sz
            Return New SizeF(.Width * Value, .Height * Value2)
         End With
      End Function
      <Extension()> _
      Public Function Scale(ByVal Sz As Size, ByVal Value As Integer, _
              Optional ByVal Value2 As Integer = Integer.MaxValue) As Size
         If Value2 = Integer.MaxValue Then Value2 = Value
         With Sz
            Return New Size(.Width * Value, .Height * Value2)
         End With
      End Function
      <Extension()> _
      Public Function Scale(ByVal Sz As Size, ByVal Value As Single, _
              Optional ByVal Value2 As Single = Single.NaN) As SizeF
         If Single.IsNaN(Value2) Then Value2 = Value
         With Sz
            Return New SizeF(.Width * Value, .Height * Value2)
         End With
      End Function

      <Extension()> _
      Public Function Scale(ByVal Sz As SizeF, ByVal Sz2 As SizeF) As SizeF
         With Sz
            Return New SizeF(.Width * Sz2.Width, .Height * Sz2.Height)
         End With
      End Function

      <Extension()> _
      Public Function Add(ByVal Sz As Size, ByVal Pt2 As PointF) As SizeF
         Return New SizeF(Pt2 + Sz)
      End Function
      <Extension()> _
      Public Function Add(ByVal Sz As Size, ByVal Pt2 As Point) As Size
         Return New Size(Pt2 + Sz)
      End Function
      <Extension()> _
      Public Function Add(ByVal Sz As SizeF, ByVal Pt2 As Point) As SizeF
         Return Sz + New SizeF(Pt2)
      End Function
      <Extension()> _
      Public Function Add(ByVal Sz As SizeF, ByVal Pt2 As PointF) As SizeF
         Return New SizeF(Pt2 + Sz)
      End Function


      <Extension()> _
      Public Function Add(ByVal Sz As Size, ByVal Sz2 As SizeF) As SizeF
         Return Sz + Sz2
      End Function
      <Extension()> _
      Public Function Add(ByVal Sz As Size, ByVal Sz2 As Size) As Size
         Return Sz + Sz2
      End Function
      <Extension()> _
      Public Function Add(ByVal Sz As SizeF, ByVal Sz2 As Size) As SizeF
         Return Sz + Sz2
      End Function
      <Extension()> _
      Public Function Add(ByVal Sz As SizeF, ByVal Sz2 As SizeF) As SizeF
         Return Sz + Sz2
      End Function

      <Extension()> _
      Public Function Add(ByVal Pt As Point, ByVal Pt2 As PointF) As PointF
         With Pt
            Return New PointF(.X + Pt2.X, .Y + Pt2.Y)
         End With
      End Function
      <Extension()> _
      Public Function Add(ByVal Pt As PointF, ByVal Pt2 As PointF) As PointF
         With Pt
            Return New PointF(.X + Pt2.X, .Y + Pt2.Y)
         End With
      End Function
      <Extension()> _
      Public Function Add(ByVal Pt As PointF, ByVal Sz As SizeF) As PointF
         Return Pt + Sz
      End Function
      <Extension()> _
      Public Function Add(ByVal Pt As Point, ByVal Sz As SizeF) As PointF
         Return Pt.ToFloat + Sz
      End Function
      <Extension()> _
      Public Function Add(ByVal Pt As Point, ByVal Pt2 As Point) As Point
         With Pt
            Return New Point(.X + Pt2.X, .Y + Pt2.Y)
         End With
      End Function
      <Extension()> _
      Public Function Add(ByVal Pt As Point, ByVal x As Integer, ByVal y As Integer) As Point
         With Pt
            Return New Point(.X + x, .Y + y)
         End With
      End Function

      ''' <summary>returns Rectangle.Union(Subj, obj) </summary>
      <Extension()> _
      Public Function Add(ByVal Subj As Rectangle, ByVal obj As Rectangle) As Rectangle
         Return Rectangle.Union(Subj, obj)
      End Function
      ''' <summary> returns a Rectangle with enlarged Size </summary>
      <Extension()> _
      Public Function Add(ByVal Subj As Rectangle, ByVal sz As Size) As Rectangle
         Return New Rectangle(Subj.Location, Subj.Size + sz)
      End Function
      ''' <summary> returns Subj.Offset(pt) </summary>
      <Extension()> _
      Public Function Add(ByVal Subj As Rectangle, ByVal pt As Point) As Rectangle
         Subj.Offset(pt)
         Return Subj
      End Function
      <Extension()> _
      Public Function Subtract(ByVal Sz1 As Size, ByVal w As Integer, ByVal h As Integer) As Size
         Return Size.Subtract(Sz1, New Size(w, h))
      End Function
      <Extension()> _
      Public Function Subtract(ByVal Sz1 As Size, ByVal Sz2 As Size) As Size
         Return Size.Subtract(Sz1, Sz2)
      End Function

      <Extension()> _
      Public Function Subtract(ByVal Pt As Point, ByVal Pt2 As Point) As Point
         Pt.Offset(-Pt2.X, -Pt2.Y)
         Return Pt
      End Function

      <Extension()> _
      Public Function Subtract(ByVal Pt As PointF, ByVal Pt2 As PointF) As PointF
         With Pt
            Return New PointF(.X - Pt2.X, .Y - Pt2.Y)
         End With
      End Function

      <Extension()> _
      Public Sub Offset(ByRef Pt As PointF, ByVal Pt2 As PointF)
         Pt += New SizeF(Pt2)
      End Sub
      <Extension()> _
      Public Sub Offset(ByRef Pt As PointF, ByVal X As Single, ByVal Y As Single)
         Pt += New SizeF(X, Y)
      End Sub

      <Extension()> _
      Public Function Contains(ByVal Sz1 As SizeF, ByVal Pt2 As PointF) As Boolean
         With Pt2
            Return (New RectangleF(PointF.Empty, Sz1)).Contains(Pt2)
         End With
      End Function
      <Extension()> _
      Public Function Contains(ByVal Sz1 As SizeF, ByVal Sz2 As SizeF) As Boolean
         With Sz2
            Return (New RectangleF(PointF.Empty, Sz1)).Contains(New PointF(.Width, .Height))
         End With
      End Function
      <Extension()> _
      Public Function Contains(ByVal Sz1 As Size, ByVal Sz2 As Size) As Boolean
         Return (New Rectangle(Point.Empty, Sz1)).Contains(New Point(Sz2))
      End Function
      <Extension()> _
      Public Function Contains(ByVal Sz As SizeF, ByVal Rct As RectangleF) As Boolean
         Return (New RectangleF(PointF.Empty, Sz)).Contains(Rct)
      End Function
      <Extension()> _
      Public Function Contains(ByVal Sz As Size, ByVal Rct As RectangleF) As Boolean
         Return (New RectangleF(Point.Empty, Sz)).Contains(Rct)
      End Function

      <Extension()> _
      Public Function InflateX(ByVal Subj As Rectangle, ByVal amount As Integer) As Rectangle
         Return Rectangle.Inflate(Subj, amount, amount)
      End Function
      <Extension()> _
      Public Function InflateX(ByVal Subj As Rectangle, ByVal X As Integer, ByVal Y As Integer) As Rectangle
         Return Rectangle.Inflate(Subj, X, Y)
      End Function
      <Extension()> _
      Public Function InflatePd(ByVal Subj As Rectangle, Optional ByVal left As Integer = 0, Optional ByVal top As Integer = 0, Optional ByVal right As Integer = 0, Optional ByVal bottom As Integer = 0) As Rectangle
         With Subj
            Return New Rectangle(.X - left, .Y - top, .Width + left + right, .Height + top + bottom)
         End With
      End Function
      <Extension()> _
      Public Function InflateX(ByVal Subj As RectangleF, ByVal X As Single, ByVal Y As Single) As RectangleF
         Return RectangleF.Inflate(Subj, X, Y)
      End Function

      <Extension()> _
      Public Function IntersectX(ByVal Subj As RectangleF, ByVal Rct As RectangleF) As RectangleF
         IntersectX = Subj
         IntersectX.Intersect(Rct)
      End Function

      <Extension()> _
      Public Function IntersectX(ByVal Subj As Rectangle, ByVal Rct As Rectangle) As Rectangle
         IntersectX = Subj
         IntersectX.Intersect(Rct)
      End Function

      <Extension()> _
      Public Sub Intersect(ByRef Rct As Rectangle, ByVal Sz As Size)
         Rct.Intersect(New Rectangle(Point.Empty, Sz))
      End Sub

      <Extension()> _
      Public Sub Intersect(ByRef Rct As Rectangle, ByVal Pt As Point)
         With Pt
            Rct.Intersect(New Rectangle(0, 0, .X, .Y))
         End With
      End Sub

      <Extension()> _
      Public Sub Intersect(ByRef Rct As RectangleF, ByVal Sz As SizeF)
         Rct.Intersect(New RectangleF(PointF.Empty, Sz))
      End Sub

      <Extension()> _
      Public Sub Intersect(ByRef Rct As RectangleF, ByVal Pt As PointF)
         With Pt
            Rct.Intersect(New RectangleF(0, 0, .X, .Y))
         End With
      End Sub

      <Extension()> _
      Public Function Intersect(ByVal subj As Size, ByVal other As Size) As Size
         Return New Size( _
            If(subj.Width < other.Width, subj.Width, other.Width), _
            If(subj.Height < other.Height, subj.Height, other.Height))
      End Function

      <Extension()> _
      Public Function ClipIn(ByVal Pt As Point, ByVal Clip As Rectangle) As Point
         With Clip
            If .Contains(Pt) Then Return Pt
            If Pt.X < .X Then
               Pt.X = .X
            ElseIf Pt.X >= .Right Then
               Pt.X = .Right
            End If
            If Pt.Y < .Y Then
               Pt.Y = .Y
            ElseIf Pt.Y >= .Bottom Then
               Pt.Y = .Bottom
            End If
         End With
         Return Pt
      End Function
      <Extension()> _
      Public Function ClipIn(ByVal Pt As Point, ByVal Clip As Size) As Point
         Return Pt.ClipIn(New Rectangle(Point.Empty, Clip))
      End Function
      ''' <returns>
      ''' die Location eines innerhalb von outer geclippten Rectangles
      ''' </returns>
      <Extension()> _
      Public Function ClipIn(ByVal inner As Rectangle, ByVal outer As Size) As Point
         With inner
            If .Width > outer.Width Then
               .X = (outer.Width - .Width) \ 2
            ElseIf .X < 0 Then
               .X = 0
            ElseIf .Right < outer.Width Then
               .X = outer.Width - .Width
            End If
            If .Height > outer.Height Then
               .Y = (outer.Height - .Height) \ 2
            ElseIf .Y < 0 Then
               .Y = 0
            ElseIf .Right < outer.Height Then
               .Y = outer.Height - .Height
            End If
            Return .Location
         End With
      End Function

      ''' <returns>the rectangle, when Sz's Middle is set at Pt</returns>
      <Extension()> _
      Public Function At(ByVal Sz As Size, ByVal Pt As Point) As Rectangle
         Pt.Offset(-Sz.Width \ 2, -Sz.Height \ 2)
         Return New Rectangle(Pt, Sz)
      End Function

      ''' <returns>
      ''' die Location eines innerhalb von Target ausgerichteten Rectangles mit Size Subj
      ''' </returns>
      <Extension()> _
      Public Function AlignIn( _
            ByVal Subj As Size, _
            ByVal Target As Size, _
            ByVal Alignment As ContentAlignment) As Point
         Dim al = Alignment.Decompose
         Return New Point( _
            ((Target.Width - Subj.Width) * al(1)) \ 2, _
            ((Target.Height - Subj.Height) * al(0)) \ 2)
      End Function

      ''' <returns>
      ''' ein innerhalb von Target ausgerichteten Rectangle mit Size Subj
      ''' </returns>
      <Extension()> _
      Public Function AlignIn( _
            ByVal Subj As Size, _
            ByVal Target As Rectangle, _
            ByVal Alignment As ContentAlignment) As Rectangle
         AlignIn = New Rectangle(AlignIn(Subj, Target.Size, Alignment), Subj)
         AlignIn.Offset(Target.Location)
      End Function
      ''' <summary>
      ''' zerlegt das ContentAlignment in vertikale und horizontale Komponente,
      ''' jeweils in Werten von 0 - 2
      ''' </summary>
      <Extension()> _
      Public Function Decompose(ByVal subj As ContentAlignment) As Integer()
         Dim n = CInt(Math.Log(subj, 2))
         Return New Integer() {n >> 2, n And 3}
      End Function

   End Module
End Namespace

