﻿Imports System.Linq
Imports System.Collections
Imports System.Collections.Generic
Imports System.Data
Imports System.Diagnostics
Imports System.Runtime.CompilerServices
Imports System.ComponentModel
Namespace System.Windows.Forms

   Public Module BindingSourceXX

      Private _PlugInfos As New ComponentProperty(Of BindingSource, [Set](Of Object, String))(Function(bs) New [Set](Of Object, String)())

#Region "EnterSuspendListEvents"

      Private _suspendListEvents As New ComponentProperty(Of BindingSource, ConditionalActionFrame)(AddressOf CreateActionFrame)

      Private Function _exit(ByVal bs As BindingSource) As Object
         bs.RaiseListChangedEvents = True
         bs.ResetBindings(False)
         Return Nothing
      End Function

      Private Function CreateActionFrame(ByVal bs As BindingSource) As ConditionalActionFrame
         Dim condition As Func(Of Boolean) = Function() bs.RaiseListChangedEvents
         Dim enter As Action = Function() bs.RaiseListChangedEvents.Assign(False)
         Dim [exit] As Action = Function() _exit(bs)
         Return New ConditionalActionFrame(condition, enter, [exit])
      End Function

      <Obsolete("better use TableEventEnabler to associate Table-Filling with Event-Suspending")> _
      <Extension()> _
      Public Function EnterSuspendListEvents(ByVal bs As BindingSource) As IDisposable
         Return _suspendListEvents(bs).Enter()
      End Function

#End Region 'EnterSuspendListEvents

      <Extension()> _
      Public Sub SynchronisizeSources(ByVal components As IContainer, ByVal row As DataRow)
         Dim primVals = New Dictionary(Of DataTable, [Set](Of List(Of BindingSource), DataRow))
         Enumerate(row, primVals)
         primVals(row.Table) = NewSet(New List(Of BindingSource), row)
         For Each bs In components.Components.OfType(Of BindingSource)()
            If Not TypeOf bs.List Is DataView Then Return
            Dim item As [Set](Of List(Of BindingSource), DataRow) = Nothing
            If primVals.TryGetValue(bs.DataTable, item) Then item.A.Add(bs)
         Next
         For Each itm In primVals.Values
            For Each bs In itm.A
               bs.MoveTo(itm.B)
            Next
         Next
      End Sub

      Private Sub Enumerate(ByVal row As DataRow, ByVal primVals As Dictionary(Of DataTable, [Set](Of List(Of BindingSource), DataRow)))
         For Each rl In row.Table.ParentRels
            If rl.ChildKeyConstraint.Null Then Continue For
            Dim parentRow = row.GetParentRow(rl)
            If parentRow.Null Then Continue For
            Enumerate(parentRow, primVals)
            If Not primVals.ContainsKey(rl.ParentTable) Then primVals.Add(rl.ParentTable, NewSet(New List(Of BindingSource), parentRow))
         Next
      End Sub

      <Extension()> _
      Public Function Plugged(ByVal bs As BindingSource) As Boolean
         Return Not TypeOf bs.DataSource Is Type
      End Function

      <Extension()> _
      Public Sub Plugged(ByVal bs As BindingSource, ByVal value As Boolean)
         If value <> TypeOf bs.DataSource Is Type Then Return
         With _PlugInfos(bs)
            If value Then
               If .A Is Nothing Then
                  Throw New Exception("kann nich pluggen, da nicht initialisiert")
               End If
               bs.ChangeBinding(.A, .B)
            Else
               If .A Is Nothing Then
                  .A = bs.DataSource
                  .B = bs.DataMember
               End If
               Dim tb = bs.DataTable
               bs.ChangeBinding(tb.DataSet.GetType, tb.TableName)
            End If
         End With
      End Sub

      <Extension()> _
      Public Function BindID(ByVal bs As BindingSource) As String
         If bs.Null Then Return "Null"
         Dim src = TryCast(bs.DataSource, BindingSource)
         Return If(src.Null, bs.DataSource.GetType().Name, BindID(src)).And("\", bs.DataMember)
      End Function

   End Module

End Namespace
