﻿Imports System.Runtime.CompilerServices
Imports System.Drawing
Imports System.Reflection

Namespace System.Windows.Forms
   Public Module ScrollbarX


      ''' <summary>
      ''' Normiert ScrollBar.Value auf einen Wert zw. 0 und 1
      ''' </summary>
      Public Property NormedScrollValue(ByVal Scrollbar As ScrollBar) As Double
         Get
            With Scrollbar
               Return .Value / (.Maximum - (.LargeChange - 1))
            End With
         End Get
         Set(ByVal value As Double)
            If Not value.IsBetween(0.0, 1.0) Then Throw New Exception( _
                String.Concat( _
                    "Value '", value, "' liegt nicht zwischen 0 und 1."))
            With Scrollbar
               Dim Val As Integer = _
                   CInt(value * (.Maximum - (.LargeChange - 1)))
               If Val = .Value Then Return
               .Value = Val
            End With
         End Set
      End Property

      ''' <summary>
      ''' Normiert ScrollBar.Value auf einen Wert zw. ScaleMin und ScaleMax 
      ''' </summary>
      Public Property NormedScrollValue( _
              ByVal ScrollBar As ScrollBar, _
              ByVal ScaleMin As Double, _
              ByVal ScaleMax As Double) As Double
         Get
            Return NormedScrollValue(ScrollBar) * (ScaleMax - ScaleMin) + ScaleMin
         End Get
         Set(ByVal value As Double)
            NormedScrollValue(ScrollBar) = (value - ScaleMin) / (ScaleMax - ScaleMin)
         End Set
      End Property
   End Module
End Namespace
