Imports System.ComponentModel

Namespace System

   Public Class DisposableBase(Of T As IDisposable) : Implements IDisposable

      Private disposedValue As Boolean = False
      Private Shared _MyType As Type = GetType(T)
      Public ReadOnly Property IsDissposed() As Boolean
         Get
            Return disposedValue
         End Get
      End Property

      Protected Overridable Sub Dispose(ByVal disposing As Boolean)
         If Me.disposedValue Then Return
         If disposing Then DisposableAttribute.DisposeFields(_MyType, Me)
         Me.disposedValue = True
      End Sub

      Public Sub Dispose() Implements IDisposable.Dispose
         Dispose(True)
         GC.SuppressFinalize(Me)
      End Sub
      Protected Overrides Sub Finalize()
         Dispose(False)
         MyBase.Finalize()
      End Sub

   End Class

End Namespace
