﻿Imports System.Runtime.CompilerServices
Imports System.Text

Namespace System.IO

   Public Module PathX
      Public Function GetFullnameWithoutExtension(ByVal s As String) As String
         Dim l = Path.GetExtension(s).Length
         If Not s.Contains(":"c) Then s = Path.GetFullPath(s)
         Return s.Substring(0, s.Length - l)
      End Function
   End Module

   Public Module SystemIOX
      Private Const _Sep As Char = ChrW(&HF018)
      Private _Newlinelength As Integer = Environment.NewLine.Length + 1

      ''' <summary>
      ''' returns data-representing strings, which have been written with (Extension)TextWriter.WriteRow()
      ''' </summary>
      <Extension()> _
      Public Function ReadRow(ByVal subj As TextReader) As String()
         Dim sb As New StringBuilder
         Do
            Dim s = subj.ReadLine
            If s.Null Then Throw New Exception("SystemIOX.ReadRow(): End of File reached")
            sb.AppendLine(s)
         Loop Until sb(sb.Length - _Newlinelength) = _Sep
         Return sb.ToString(0, sb.Length - _Newlinelength).Split(_Sep)
      End Function

      ''' <summary>
      ''' writes a data-line, using a special separator. read it with (Extension)TextReader.ReadRow() 
      ''' </summary>
      <Extension()> _
      Public Sub WriteRow(ByVal subj As TextWriter, ByVal data As IEnumerable(Of String))
         subj.WriteLine(String.Join(_Sep, data) & _Sep)
      End Sub

   End Module

End Namespace